'$INCLUDE: 'qbx.bi'
DECLARE SUB mousedrv (ax%, bx%, cx%, dx%)
DECLARE SUB ts ()
DECLARE SUB loadkeys ()
DECLARE SUB gfx ()
DECLARE SUB snd ()
DECLARE SUB fread ()
DECLARE SUB fwrite ()
DECLARE FUNCTION domenu% (title$, mnu$())
DECLARE SUB center (row%, text$)
DECLARE SUB keyassign (na$, k$)
DECLARE FUNCTION getkey$ ()
DEFINT A-Z

TYPE keydata
  start AS STRING * 2
  select AS STRING * 2
  up AS STRING * 2
  down AS STRING * 2
  right AS STRING * 2
  left AS STRING * 2
  volup AS STRING * 2
  voldown AS STRING * 2
  l AS STRING * 2
  r AS STRING * 2
  a AS STRING * 2
  B AS STRING * 2
  x AS STRING * 2
  y AS STRING * 2
END TYPE
DIM SHARED keys AS keydata
DIM k AS STRING * 2

SCREEN 13
mousedrv 0, 0, 0, 0
loadkeys
CLS
center 10, "GP2X DOSBox Tests"
center 12, "Created by Chronoboy"
center 20, "Press <Start>"
DO
  k = getkey$
LOOP UNTIL k = keys.start
CLS
DIM mnu$(7)
mnu$(1) = "File write test"
mnu$(2) = "File read test"
mnu$(3) = "Graphics test"
mnu$(4) = "Sound test"
mnu$(5) = "Touchscreen test"
mnu$(6) = "Reconfigure keys"
mnu$(7) = "Exit"
DO
  x = domenu("GP2X DOSBox Tests", mnu$())
  CLS
  IF x = 1 THEN fwrite
  IF x = 2 THEN fread
  IF x = 3 THEN gfx
  IF x = 4 THEN snd
  IF x = 5 THEN ts
  IF x = 6 THEN KILL "gp2x.key": loadkeys
LOOP UNTIL x = 7

SUB center (row, text$)
LOCATE row, 21 - LEN(text$) / 2
PRINT text$
END SUB

FUNCTION domenu (title$, mnu$())
DIM k AS STRING * 2
CLS
center 1, title$
FOR i = 1 TO UBOUND(mnu$)
  center i + 8, mnu$(i)
NEXT i
i = 1
DO
  COLOR 4
  center i + 8, mnu$(i)
  k = getkey$
  COLOR 15
  center i + 8, mnu$(i)
  IF k = keys.down THEN i = i + 1
  IF k = keys.up THEN i = i - 1
  IF i > UBOUND(mnu$) THEN i = 1
  IF i < 1 THEN i = UBOUND(mnu$)
LOOP UNTIL k = keys.a
domenu = i
END FUNCTION

SUB fread
DIM k AS STRING * 2
center 1, "File read test"
PRINT
PRINT "Attempting to read text file..."
f = FREEFILE
OPEN "fread.txt" FOR INPUT AS #f
LINE INPUT #f, a$
LINE INPUT #f, B$
CLOSE #f
PRINT a$
PRINT B$
PRINT "Press anykey to continue..."
k = getkey$
CLS
PRINT "Attempting to read binary file..."
OPEN "fread.bin" FOR BINARY AS #f
GET #f, , k
GET #f, , v1
GET #f, , v2
GET #f, , v3
GET #f, , v4
CLOSE #f
PRINT "K="; k
PRINT "v1="; v1
PRINT "v2="; v2
PRINT "v3="; v3
PRINT "v4="; v4
PRINT "Press anykey to continue..."
k = getkey$
CLS
END SUB

SUB fwrite
DIM k AS STRING * 2
center 1, "File write test"
PRINT
PRINT "Creating new text file...";
f = FREEFILE
OPEN "test.txt" FOR OUTPUT AS #f
PRINT #f, "This is a test text file."
PRINT #f, "Lets see if this works..."
tmp = LOF(f)
CLOSE #f
PRINT "done."
PRINT "Verifying action..."
FILES
PRINT "Press anykey to continue..."
k = getkey$
CLS
PRINT "Appending to text file...";
OPEN "test.txt" FOR APPEND AS #f
PRINT #f, "This data is appended to the file."
tmp1 = LOF(f)
CLOSE #f
PRINT "done."
PRINT "Verifying action..."
PRINT "Old size:"; tmp
PRINT "New size:"; tmp1
IF tmp1 > tmp THEN PRINT "Looks good so far."
PRINT "Press anykey to continue..."
k = getkey$
CLS
PRINT "Deleting file...";
KILL "test.txt"
PRINT "done."
PRINT "Verifying action..."
FILES
PRINT "Press anykey to continue..."
k = getkey$
CLS
PRINT "Creating a directory...";
MKDIR "test"
PRINT "done."
PRINT "Verifying action..."
FILES
PRINT "Press anykey to continue..."
k = getkey$
CLS
PRINT "Deleting a directory...";
RMDIR "test"
PRINT "done."
PRINT "Verifying action..."
FILES
PRINT "Press anykey to continue..."
k = getkey$
CLS
PRINT "Creating binary file...";
OPEN "test.bin" FOR BINARY AS #f
hdr$ = "BIN*" + CHR$(0)
v1 = 8: v2 = 43: v3 = 76
chk = v1 + v2 + v3
PUT #f, , hdr$
PUT #f, , v1
PUT #f, , v2
PUT #f, , v3
PUT #f, , chk
CLOSE #f
PRINT "done."
PRINT "Verifying action..."
FILES
PRINT "Press anykey to continue..."
k = getkey$
CLS
PRINT "Checking binary file checksum...";
OPEN "test.bin" FOR BINARY AS #f
GET #f, 6, z1
GET #f, , z2
GET #f, , z3
GET #f, , z4
CLOSE #f
z5 = z1 + z2 + z3
IF z4 = z5 THEN PRINT "OK!" ELSE PRINT "Error."
PRINT "Press anykey to continue..."
k = getkey$
END SUB

FUNCTION getkey$
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
getkey$ = k$
END FUNCTION

SUB gfx
DIM k AS STRING * 2
center 1, "Graphics test"
center 21, "Use your d-pad to draw!"
center 22, "Press <Start> to exit"
x = 100: y = 100
DO
  c = INT(RND * 255) + 1
  PSET (x, y), c
  k = getkey$
  IF k = keys.up THEN y = y - 1
  IF k = keys.down THEN y = y + 1
  IF k = keys.left THEN x = x - 1
  IF k = keys.right THEN x = x + 1
LOOP UNTIL k = keys.start
DO
  k = INKEY$
  x1 = INT(RND * 300) + 1
  y1 = INT(RND * 180) + 1
  x2 = x1 + INT(RND * 320) + 1
  y2 = y2 + INT(RND * 200) + 1
  IF x2 > 320 THEN x2 = 320
  IF y2 > 200 THEN y2 = 200
  bc = INT(RND * 255) + 1
  die2 = INT(RND * 100) + 1
  c = INT(RND * 255) + 1
  IF die2 > 50 THEN
    LINE (x1, y1)-(x2, y2), bc, B
  ELSE
    CIRCLE (x1, y1), x1, bc
  END IF
  die = INT(RND * 100) + 1
  IF die > 50 THEN
    a$ = CHR$(INT(x1 / 2)) + CHR$(INT(y1 / 2)) + CHR$(INT(x2 / 2)) + CHR$(INT(y2 / 2)) + CHR$(bc) + CHR$(c) + CHR$(die) + CHR$(die2)
    PAINT (x1 + 1, y1 + 1), a$, bc
  ELSE
    PAINT (x1 + 1, y1 + 1), c, bc
  END IF
LOOP UNTIL k = keys.start
END SUB

SUB keyassign (na$, k$)
DIM tmp1 AS STRING * 2
DIM tmp2 AS STRING * 2
sp$ = SPACE$(5)
DO
  center 10, sp$ + "Please press " + na$ + "..." + sp$
  tmp1 = getkey$
  center 10, sp$ + "Press again to confirm..." + sp$
  tmp2 = getkey$
LOOP UNTIL tmp1 = tmp2
k$ = tmp1
END SUB

SUB loadkeys
PRINT "Checking for settings...";
f = FREEFILE
OPEN "gp2x.key" FOR BINARY AS #f
kx = LOF(f)
IF kx > 0 THEN GET #f, , keys
CLOSE #f
IF kx = 0 THEN
  PRINT "not found."
  center 20, "Lets begin by assigning our keys..."
  keyassign "Home/Start", keys.start
  keyassign "Select", keys.select
  keyassign "Up", keys.up
  keyassign "Down", keys.down
  keyassign "Left", keys.left
  keyassign "Right", keys.right
  keyassign "Vol+", keys.volup
  keyassign "Vol-", keys.voldown
  keyassign "L", keys.l
  keyassign "R", keys.r
  keyassign "A", keys.a
  keyassign "B", keys.B
  keyassign "X", keys.x
  keyassign "Y", keys.y
  PRINT "Saving key settings...";
  f = FREEFILE
  OPEN "gp2x.key" FOR BINARY AS #f
  PUT #f, , keys
  CLOSE #f
  PRINT "done."
END IF
END SUB

SUB mktest
f = FREEFILE
OPEN "fread.txt" FOR OUTPUT AS #f
PRINT #f, "This is a test text file."
PRINT #f, "Line 2."
CLOSE #f
OPEN "fread.bin" FOR BINARY AS #f
k$ = "K*": v1 = 5: v2 = 1: v3 = 9: v4 = 9
PUT #f, , k$
PUT #f, , v1
PUT #f, , v2
PUT #f, , v3
PUT #f, , v4
CLOSE #f
END SUB

SUB mousedrv (ax, bx, cx, dx)
DIM regs AS RegType
regs.ax = ax: regs.bx = bx: regs.cx = cx: regs.dx = dx
CALL Interrupt(&H33, regs, regs)
ax = regs.ax: bx = regs.bx: cx = regs.cx: dx = regs.dx
END SUB

SUB snd
center 1, "Sound test"
PLAY "abcdefg"
END SUB

SUB ts
DIM k AS STRING * 2
DIM x1(5), y1(5)
x1(1) = 100: y1(1) = 100
x1(2) = 30: y1(2) = 130
x1(3) = 40: y1(3) = 60
x1(4) = 110: y1(4) = 40
x1(5) = 10: y1(5) = 90
center 1, "Touchscreen test"
center 22, "Use the stylis to tap each box"
f = FREEFILE
OPEN "tsdebug.txt" FOR OUTPUT AS #f
FOR i = 1 TO 5
  PRINT #f, "X1:"; x1(i)
  PRINT #f, "Y1:"; y1(i)
  LINE (x1(i), y1(i))-(x1(i) + 10, y1(i) + 10), 4, BF
  IF mhide = 0 THEN mousedrv 1, 0, 0, 0
  d = 0
  DO
    k = INKEY$
    IF k = keys.start THEN d = 1
    IF k = keys.select THEN mhide = 1: mousedrv 2, 0, 0, 0
    mousedrv 3, B, x2, y2
    x2 = x2 / 2
    IF B = 1 THEN
      PRINT #f, "X2:"; x2
      PRINT #f, "Y2:"; y2
      IF mhide = 0 THEN mousedrv 2, 0, 0, 0
      LINE (x2 - 5, y2 - 5)-(x2 + 5, y2 + 5), 2, BF
      SLEEP 1
      d = 1
    END IF
  LOOP UNTIL d = 1
NEXT i
CLOSE #f
END SUB

